Chapter 11 | Native-code compilation (ocamlopt)

This chapter describes the Objective Caml high-performance native-code compiler `ocamlopt`, which compiles Caml source files to native code object files and link these object files to produce standalone executables.
The native-code compiler is only available on certain platforms. It produces code that runs faster than the bytecode produced by `ocamlc`, at the cost of increased compilation time and executable code size. Compatibility with the bytecode compiler is extremely high: the same source code should run identically when compiled with `ocamlc` and `ocamlopt`.
It is not possible to mix native-code object files produced by `ocamlc` with bytecode object files produced by `ocamlopt`: a program must be compiled entirely with `ocamlopt` or entirely with `ocamlc`. Native-code object files produced by `ocamlopt` cannot be loaded in the toplevel system `ocaml`.

11.1 | Overview of the compiler

The `ocamlopt` command has a command-line interface very close to that of `ocamlc`. It accepts the same types of arguments:

- Arguments ending in `.mli` are taken to be source files for compilation unit interfaces. Interfaces specify the names exported by compilation units: they declare value names with their types, define public data types, declare abstract data types, and so on. From the file x`.mli`, the `ocamlopt` compiler produces a compiled interface in the file x`.cmi`. The interface produced is identical to that produced by the bytecode compiler `ocamlc`.
- Arguments ending in `.ml` are taken to be source files for compilation unit implementations. Implementations provide definitions for the names exported by the unit, and also contain expressions to be evaluated for their side-effects. From the file x`.ml`, the `ocamlopt` compiler produces two files: x`.o`, containing native object code, and x`.cmx`, containing extra information for linking and optimization of the clients of the unit. The compiled implementation should always be referred to under the name x`.cmx` (when given a `.o` file, `ocamlopt` assumes that it contains code compiled from C, not from Caml).
  The implementation is checked against the interface file x`.mli` (if it exists) as described in the manual for `ocamlc` (chapter 8).
- Arguments ending in `.cmx` are taken to be compiled object code. These files are linked together, along with the object files obtained by compiling `.ml` arguments (if any), and the Caml Light standard library, to produce a native-code executable program. The order in which `.cmx` and `.ml` arguments are presented on the command line is relevant: compilation units are initialized in that order at run-time, and it is a link-time error to use a component of a unit before having initialized it. Hence, a given x`.cmx` file must come before all `.cmx` files that refer to the unit x.
- Arguments ending in `.cmxa` are taken to be libraries of object code. Such a library packs in two files (lib`.cmxa` and lib`.a`) a set of object files (`.cmx`/`.o` files). Libraries are build with `ocamlopt -a` (see the description of the `-a` option below). The object files contained in the library are linked as regular `.cmx` files (see above), in the order specified when the library was built. The only difference is that if an object file contained in a library is not referenced anywhere in the program, then it is not linked in.
- Arguments ending in `.c` are passed to the C compiler, which generates a `.o` object file. This object file is linked with the program.
- Arguments ending in `.o` or `.a` are assumed to be C object files and libraries. They are linked with the program.

The output of the linking phase is a regular Unix executable file. It does not need `ocamlrun` to run.

11.2 | Options

The following command-line options are recognized by `ocamlopt`.

`-a`
  Build a library (`.cmxa`/`.a` file) with the object files (`.cmx`/`.o` files) given on the command line, instead of linking them into an executable file. The name of the library can be set with the `-o` option. The default name is `library.cmxa`.
  If `-cclib` or `-ccopt` options are passed on the command line, these options are stored in the resulting `.cmxa` library. Then, linking with this library automatically adds back the `-cclib` and `-ccopt` options as if they had been provided on the command line, unless the `-noautolink` option is given.
`-c`
  Compile only. Suppress the linking phase of the compilation. Source code files are turned into compiled files, but no executable file is produced. This option is useful to compile modules separately.
`-cc` ccomp
  Use ccomp as the C linker called to build the final executable and as the C compiler for compiling `.c` source files.
`-cclib` `-l` libname
  Pass the `-l` libname option to the linker. This causes the given C library to be linked with the program.
`-ccopt` option
  Pass the given option to the C compiler and linker. For instance, `-ccopt -L` dir causes the C linker to search for C libraries in directory dir.
`-compact`
  Optimize the produced code for space rather than for time. This results in slightly smaller but slightly slower programs. The default is to optimize for speed.
`-i`
  Cause the compiler to print all defined names (with their inferred types or their definitions) when compiling an implementation (`.ml` file). This can be useful to check the types inferred by the compiler. Also, since the output follows the syntax of interfaces, it can help in writing an explicit interface (`.mli` file) for a file: just redirect the standard output of the compiler to a `.mli` file, and edit that file to remove all declarations of unexported names.
`-I` directory
  Add the given directory to the list of directories searched for compiled interface files (`.cmi`) and compiled object code files (`.cmx`). By default, the current directory is searched first, then the standard library directory. Directories added with `-I` are searched after the current directory, in the order in which they were given on the command line, but before the standard library directory.
`-inline` n
  Set aggressiveness of inlining to n, where n is a positive integer. Specifying `-inline 0` prevents all functions from being inlined, except those whose body is smaller than the call site. Thus, inlining causes no expansion in code size. The default aggressiveness, `-inline 1`, allows slightly larger functions to be inlined, resulting in a slight expansion in code size. Higher values for the `-inline` option cause larger and larger functions to become candidate for inlining, but can result in a serious increase in code size.
`-labels`
  Switch to the commuting label mode of compilation, meaning that labeling rules are applied strictly, and commutation between labeled arguments is allowed. (See section 2.1.4.) This mode cannot be used to compile a program written in the default classic style, but modules written in the two styles can be mixed in the same application.
`-linkall`
  Forces all modules contained in libraries to be linked in. If this flag is not given, unreferenced modules are not linked in. When building a library (`-a` flag), setting the `-linkall` flag forces all subsequent links of programs involving that library to link all the modules contained in the library.
`-noassert`
  Turn assertion checking off: assertions are not compiled. This flag has no effect when linking already compiled files.
`-noautolink`
  When linking `.cmxa` libraries, ignore `-cclib` and `-ccopt` options potentially contained in the libraries (if these options were given when building the libraries). This can be useful if a library contains incorrect specifications of C libraries or C options; in this case, during linking, set `-noautolink` and pass the correct C libraries and options on the command line.
`-o` exec-file
  Specify the name of the output file produced by the linker. The default output name is `a.out`, in keeping with the Unix tradition. If the `-a` option is given, specify the name of the library produced. If the `-output-obj` option is given, specify the name of the output file produced.
`-output-obj`
  Cause the linker to produce a C object file instead of an executable file. This is useful to wrap Caml code as a C library, callable from any C program. See chapter 17, section 17.7.5. The name of the output object file is `camlprog.o` by default; it can be set with the `-o` option.
`-p`
  Generate extra code to write profile information when the program is executed. The profile information can then be examined with the analysis program `gprof`. (See chapter 16 for more information on profiling.) The `-p` option must be given both at compile-time and at link-time. Linking object files not compiled with `-p` is possible, but results in less precise profiling.
  Unix:

  > See the Unix manual page for `gprof(1)` for more information about the profiles.
  > Full support for `gprof` is only available for certain platforms (currently: Intel x86/Linux and Alpha/Digital Unix). On other platforms, the `-p` option will result in a less precise profile (no call graph information, only a time profile).

  Windows:

  > The `-p` option does not work under Windows.

`-pp` command
  Cause the compiler to call the given command as a preprocessor for each source file. The output of command is redirected to an intermediate file, which is compiled. If there are no compilation errors, the intermediate file is deleted afterwards. The name of this file is built from the basename of the source file with the extension `.ppi` for an interface (`.mli`) file and `.ppo` for an implementation (`.ml`) file.
`-rectypes`
  Allow arbitrary recursive types during type-checking. By default, only recursive types where the recursion goes through an object type are supported.
`-S`
  Keep the assembly code produced during the compilation. The assembly code for the source file x`.ml` is saved in the file x`.s`.
`-thread`
  Compile or link multithreaded programs, in combination with the `threads` library described in chapter 23. What this option actually does is select a special, thread-safe version of the standard library.
`-unsafe`
  Turn bound checking off on array and string accesses (the `v.(i)` and `s.[i]` constructs). Programs compiled with `-unsafe` are therefore faster, but unsafe: anything can happen if the program accesses an array or string outside of its bounds.
`-v`
  Print the version number of the compiler.
`-w` warning-list
  Enable or disable warnings according to the argument warning-list. The argument is a string of one or several characters, with the following meaning for each character:
  `A`/`a`
    enable/disable all warnings
  F/f
    enable/disable warnings for partially applied functions (i.e. `f x;` expr where the application `f x` has a function type).
  M/m
    enable/disable warnings for overriden methods.
  P/p
    enable/disable warnings for partial matches (missing cases in pattern matchings).
  S/s
    enable/disable warnings for statements that do not have type `unit` (e.g. expr1`;` expr2 when expr1 does not have type `unit`).
  U/u
    enable/disable warnings for unused (redundant) match cases.
  V/v
    enable/disable warnings for hidden instance variables.
  X/x
    enable/disable all other warnings.
  The default setting is `-w A` (all warnings enabled).

11.3 | Common errors

The error messages are almost identical to those of `ocamlc`. See section 8.4.

11.4 | Compatibility with the bytecode compiler

This section lists the known incompatibilities between the bytecode compiler and the native-code compiler. Except on those points, the two compilers should generate code that behave identically.

- The following operations abort the program (either by printing an error message or just via an hardware trap or fatal Unix signal) instead of raising an exception:
  - integer division by zero, modulus by zero;
  - stack overflow;
  - on the Alpha processor only, floating-point operations involving infinite or denormalized numbers (all other processors supported by `ocamlopt` treat these numbers correctly, as per the IEEE 754 standard).
  In particular, notice that stack overflow caused by excessively deep recursion is reported by most Unix kernels as a ``segmentation violation'' signal.
- Signals are detected only when the program performs an allocation in the heap. That is, if a signal is delivered while in a piece of code that does not allocate, its handler will not be called until the next heap allocation.

The best way to avoid running into those incompatibilities is to never trap the `Division``_``by``_``zero` and `Stack``_``overflow` exceptions, thus also treating them as fatal errors with the bytecode compiler as well as with the native-code compiler. Test the divisor before performing the operation instead of trapping the exception afterwards.